diff --git a/dwm.c b/dwm.c
index ffc8864..8c25239 100644
--- a/dwm.c
+++ b/dwm.c
@@ -401,6 +401,18 @@ attach(Client *c) {
 }
 
 void
+attachlast(Client *c) {
+	if(!c->mon->clients) {
+		attach(c);
+		return;
+	}
+	Client *at;
+	for(at = c->mon->clients; at->next; at = at->next);
+	c->next = at->next;
+	at->next = c;
+}
+
+void
 attachstack(Client *c) {
 	c->snext = c->mon->stack;
 	c->mon->stack = c;
@@ -1051,7 +1063,7 @@ manage(Window w, XWindowAttributes *wa) {
 		c->isfloating = c->oldstate = trans != None || c->isfixed;
 	if(c->isfloating)
 		XRaiseWindow(dpy, c->win);
-	attach(c);
+	attachlast(c);
 	attachstack(c);
 	XChangeProperty(dpy, root, netatom[NetClientList], XA_WINDOW, 32, PropModeAppend,
 	                (unsigned char *) &(c->win), 1);
@@ -1586,6 +1598,8 @@ spawn(const Arg *arg) {
 void
 tag(const Arg *arg) {
 	if(selmon->sel && arg->ui & TAGMASK) {
+		detach(selmon->sel);
+		attachlast(selmon->sel);
 		selmon->sel->tags = arg->ui & TAGMASK;
 		focus(NULL);
 		arrange(selmon);
